unit leved;

{ Autor : Nimmervoll Alexander E881 9425778
  Datum : Apr 97
  Beschreibung : Leveleditor fr VOD
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls, Spin, Buttons;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Main1: TMenuItem;
    Quit1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Save1: TMenuItem;
    Load1: TMenuItem;
    Modus1: TMenuItem;
    Startpunkt1: TMenuItem;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    Clear1: TMenuItem;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    Image2: TImage;
    Image1: TImage;
    Image3: TImage;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Save(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Startpunkt1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
  private
    { Private-Deklarationen }
    map : array[0..63,0..63,0..1] of integer;
    position : array[0..1] of integer;
    wallkind : integer;
    wallcolor : array[0..9] of integer;
    filename : string;
    function transgx(gx : integer) : integer;
    function transgy(gy : integer) : integer;
    procedure drawscreen;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



{ Eventbehandlung Maus-bewegen }
procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var st,stx,sty : string;
    ind : integer;
begin
  if (x<=650) and (y<=650) and (x>=20) and (y>=20) then begin
  { Maus im Fenster  }
     str(transgx(x),st);
     label1.caption:='x : '+st;
     str(transgy(y),st);
     label2.caption:='y : '+st;
  end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var kx,ky,mx,my : integer;
begin
 if (x<=650) and (y<=650) and (x>=20) and (y>=20) then begin
   { Maus im Fenster  }
   if Startpunkt1.Checked then begin
      Canvas.Pen.Mode:=pmnotXor;
      Canvas.Pen.Color:=clred;
      Canvas.Ellipse(position[0]-2,position[1]-2,position[0]+2,position[1]+2);
      position[0]:=x;
      position[1]:=y;
      Canvas.Ellipse(x-2,y-2,x+2,y+2);
      Canvas.Pen.Mode:=pmCopy;

   end else begin
      kx:=trunc(x/10) * 10; ky:=trunc(y/10)*10;
      mx:=transgx(x); my:=transgy(y);
      if (Button=mbLeft) then begin
         Canvas.Pen.Color:=wallcolor[wallkind];
         map[mx,my,1]:=wallkind;
         Canvas.MoveTo(kx,ky); Canvas.LineTo(kx,ky+10);
      end;
      if (Button=mbRight) then begin
         Canvas.Pen.Color:=wallcolor[wallkind];
         map[mx,my,0]:=wallkind;
         Canvas.MoveTo(kx,ky+10); Canvas.LineTo(kx+10,ky+10);
      end;
   end;
 end;
end;

{ Transformation von x-Gertekoord. in x-Weltkoord. }
function TForm1.transgx(gx : integer) : integer;
begin
 result := trunc((gx-20)/10);
end;

{ Transformation von y-Gertekoord. in y-Weltkoord. }
function TForm1.transgy(gy : integer) : integer;
begin
 result := trunc((650-gy)/10);
end;



{ Formular ffnen - Variablen initialisieren }
procedure TForm1.FormCreate(Sender: TObject);
var i,j : integer;


begin

  for i:=0 to 63 do begin
     for j:=0 to 63 do begin
       map[i,j,0]:=9;
       map[i,j,1]:=9;
     end;
  end;
  spinedit1.value := 90;
  position[0]:=30;
  position[1]:=640;
  filename:='c:\vod\level.dat';
  wallkind:=0;
  wallcolor[0]:=clblack;
  wallcolor[1]:=clred;
  wallcolor[2]:=clgray;
  wallcolor[9]:=clltgray;
  Canvas.Pen.Width:=2;

end;

{ Formular zeichnen }
procedure TForm1.FormPaint(Sender: TObject);
var i : integer;
begin
   drawscreen;
end;

procedure TForm1.drawscreen;
var i,j,kx,ky : integer;
begin
 Canvas.Pen.Mode :=pmCopy;
 Canvas.Pen.Color:=clblack;
 Canvas.Rectangle(10,10,660,660);
 Canvas.Floodfill(11,11,clblack,fsborder);
 Canvas.Pen.Color:=clltgray;
 i:=20;
 while (i<=650) do begin
    Canvas.PolyLine([Point(i,20),Point(i,650)]);
    Canvas.PolyLine([Point(20,i),Point(650,i)]);
    i:=i+10;
 end;
 Canvas.Pen.Mode:=pmnotXor;
 Canvas.Pen.Color:=clred;
 Canvas.Ellipse(position[0]-2,position[1]-2,position[0]+2,position[1]+2);
 Canvas.Pen.Mode:=pmCopy;
 Canvas.Pen.Width:=2;
 for j:=0 to 63 do begin
     for i:=0 to 63 do begin
         kx:=10*i+20; ky:=640-10*j;
         if (map[i,j,1] < 9) then begin
            Canvas.Pen.Color:=wallcolor[map[i,j,1]];
             Canvas.MoveTo(kx,ky); Canvas.LineTo(kx,ky+10);
         end;
         if (map[i,j,0] < 9) then begin
            Canvas.Pen.Color:=wallcolor[map[i,j,0]];
            Canvas.MoveTo(kx,ky+10); Canvas.LineTo(kx+10,ky+10);
         end;
      end;
 end;

 Canvas.Pen.Color:=wallcolor[wallkind];
 Canvas.Pen.Width:=5;
 Canvas.MoveTo(850,265); Canvas.LineTo(900,265);
 Canvas.Pen.Width:=2;

end;

{ Meneintrag Lschen }
procedure TForm1.Clear1Click(Sender: TObject);
var i,j : integer;
begin
 for i:=0 to 63 do begin
     for j:=0 to 63 do begin
       map[i,j,0]:=9;
       map[i,j,1]:=9;
     end;
 end;
 spinedit1.value := 90;
 position[0]:=30;
 position[1]:=640;
 drawscreen;
end;

{ Meneintrag beenden }
procedure TForm1.Quit1Click(Sender: TObject);
begin
  if MessageDlg('Anwendung beenden?',mtConfirmation,
    [mbYes,mbNo],0) = mrYes then Application.Terminate;
end;




procedure TForm1.Save(Sender: TObject);
var f : textfile;
    i,j : integer;
begin
 if SaveDialog1.Execute then begin
   filename:=SaveDialog1.Filename;
   assignfile(f,filename);
   rewrite(f);
   for j:=0 to 63 do begin
      for i:=0 to 63 do begin
         write(f,map[i,j,0],' ',map[i,j,1],' ');
      end;
      writeln(f);
   end;
   writeln(f, ((position[0]-20)/10):4:2);
   writeln(f,((650-position[1])/10):4:2);
   writeln(f,spinedit1.value);
   closefile(f);
 end;
end;

procedure TForm1.Load1Click(Sender: TObject);

var f : textfile;
    i,j,d,kx,ky : integer;
    s : string;
    x,y : real;
begin
 if OpenDialog1.Execute then begin
   filename:=OpenDialog1.Filename;
   assignfile(f,filename);
   reset(f);
   for j:=0 to 63 do begin
      readln(f,s);
      for i:=0 to 63 do begin
         val(s[4*i+1],map[i,j,0],d);
         val(s[4*i+3],map[i,j,1],d);
      end;
   end;
   readln(f,s);
   val(s,x,d);
   position[0]:= round(x*10)+20;
   readln(f,s);
   val(s,y,d);
   position[1]:= 650-round(y*10);
   readln(f,s);
   spinedit1.value:=strtoint(s);
   closefile(f);
   drawscreen;
 end;
end;

procedure TForm1.Startpunkt1Click(Sender: TObject);

begin
   Startpunkt1.Checked := NOT Startpunkt1.Checked;

end;


procedure TForm1.RadioButton1Click(Sender: TObject);
begin
     wallkind := 0;
     Canvas.Pen.Color:=wallcolor[wallkind];
     Canvas.Pen.Width:=5;
     Canvas.MoveTo(850,265); Canvas.LineTo(900,265);
     Canvas.Pen.Width:=2;

end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
     wallkind:=1;
     Canvas.Pen.Color:=wallcolor[wallkind];
     Canvas.Pen.Width:=5;
     Canvas.MoveTo(850,265); Canvas.LineTo(900,265);
     Canvas.Pen.Width:=2;

end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
     wallkind:=2;
     Canvas.Pen.Color:=wallcolor[wallkind];
     Canvas.Pen.Width:=5;
     Canvas.MoveTo(850,265); Canvas.LineTo(900,265);
     Canvas.Pen.Width:=2;


end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
     wallkind:=9;
     Canvas.Pen.Color:=wallcolor[wallkind];
     Canvas.Pen.Width:=5;
     Canvas.MoveTo(850,265); Canvas.LineTo(900,265);
     Canvas.Pen.Width:=2;

end;

end. { Bez_main }
